#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <process.h>
#include <math.h>
#include <nwenvrn.h>
#include <nwconn.h>
//#include <nwsync.h>
#include <nwcntask.h>
#include <signal.h>

//#include "F:\DEV\C\C_UTILS.H"
#include "F:\DEV\NLM\NLMUTILS.H"

// # fixed year 2000 bug (Apr 98)


#define  ERRORLOG        "SYS:SYSTEM\\SYS$LOG.ERR"
#define  DELAYLOG        200
#define  SECOND          1000
#define  MINUTE          60*SECOND

void main(int, char *[]) ;
void syntax(void);
void ResetLog();
void CleanUp();
void SyncLoop(void);

char  serverName[48];
int   tzh, tzm;
int   updateDelay;
int   cCode;
int   TruncLog;


void syntax(void)
{
   printf("Syntax:   'LOAD SYNC <time server> [/TZ=<time diff>] [/I=<min>] [/NL]'\n");
   printf("Examples: 'LOAD SYNC NYC_Server'\n");
   printf("          'LOAD SYNC NYC_Server /TZ=-2:30' (local server 2:30h behind)\n");
   printf("          'LOAD SYNC SF_Main /TZ=3 /I=60'  (server 3h ahead, check every hour)\n");
   printf("                add the option '/NL' to avoid comments in SYS$ERR.LOG\n");
}

long fsize(char *fname)
{
   struct stat statbuf;
   FILE *stream;

   /* open file */
   if ((stream = fopen(fname, "r")) == NULL)
      return(-1);   // file does not exist or cannot be opened

   /* get information about file */
   stat(fname, &statbuf);
   fclose(stream);
   return(statbuf.st_size);
}

long GetLogSize(void)
{
   return fsize(ERRORLOG);
}

void resetLog(long newsize)
{
   int handle;

   CreateFile(ERRORLOG, &handle, O_RDWR | O_APPEND);
   cCode = chsize(handle, newsize);
   ConsolePrintf("Change Size returned %04X\n\r", cCode);
   close(handle);
}


void CleanUp()
{
    Logout();
}


void SyncWithTarget(int targetServerID)
{
char dt1[7];
char dt2[7];
long logSize;
char y1, y2;


//    cCode = GetFileServerID(serverName, &targetServerID);
      cCode = SetCurrentFileServerID(0);
      // deallocate remote handle SYS:
      GetFileServerDateAndTime(dt1);

      cCode = SetCurrentFileServerID(targetServerID);
      // allocate remote handle SYS:
      GetFileServerDateAndTime(dt2);

      if (dt1[0]<100)
         y1 = dt1[0];
         else
         y1 = dt1[0]-100; // fix y2000 issue (for display)

      if (dt2[0]<100)
         y2 = dt2[0];
         else
         y2 = dt2[0]-100; // fix y2000 issue (for display)

      printf("Date/Time:  %02d-%02d-%02d %02d:%02d:%02d  %s\n",
                          y2, dt2[1], dt2[2], dt2[3], dt2[4], dt2[5],
                          serverName);
      printf("Date/Time:  %02d-%02d-%02d %02d:%02d:%02d  Local Time\n\n",
                          y1, dt1[1], dt1[2], dt1[3], dt1[4], dt1[5]);
      cCode = SetCurrentFileServerID(0);
      // deallocate remote handle SYS:
      IncMinute(dt2, tzm);     //  adjust for time zone
      IncHour(dt2,   tzh);     //  adjust for time zone
      if ( (dt1[0] != dt2[0]) || (dt1[1] != dt2[1]) ||
           (dt1[2] != dt2[2]) || (dt1[3] != dt2[3]) ||
           (dt1[4] != dt2[4]) || (dt1[5] != dt2[5]) )
           {
           printf("Synchronizing time ... ");
           if (TruncLog) logSize = GetLogSize();
           cCode = SetFileServerDateAndTime(dt2[0], dt2[1], dt2[2], dt2[3], dt2[4], dt2[5]);
           if (!cCode)
              {
              printf("done\n");
              delay(DELAYLOG);
              if ((TruncLog) && (logSize>=0)) resetLog(logSize);
              }
              else     errorStop(cCode, "Set Server Time", FALSE);
           }
           else printf("Time in sync ... \n");
}

void SyncLoop(void)
{
WORD fileServerID;

do
   {
   clrscr();
   printf("\n---------------------- General Information ------------------------------------\n", serverName);
   printf("SYNC.NLM will check %s every %d minutes and update the local time\n", serverName, updateDelay);
   printf("To cancel synchronization unload SYNC.NLM\n\n", serverName);

   syntax();

   gotoxy(0,12);
   printf("----------------------  Current Settings   ------------------------------------\n", serverName);
   printf("Time source:                   %s         \n",  serverName);
   printf("Time difference:               %+02d:%02d h\n", tzh, abs(tzm));
   printf("Synchronization Interval:      %d min \n\n",    updateDelay);

	cCode = AttachToFileServer(serverName, &fileServerID);
   // Create servive connection
   // deallocate remote handle SYS:
   // allocate   remote handle SYS:
	if (cCode == 0) SyncWithTarget(fileServerID);
      else
      {
      errorStop(cCode, "Cannot Attach to Target Server", FALSE);
      printf("\n");
      printf("SYNC will continue to operate and try to get a connection.\n\n");
      printf("If you mistyped the name of the time source server (%s),\n", serverName);
      printf("unload SYNC and re-load it with the proper server name.\n");
      }
   LogoutFromFileServer(fileServerID);
   // Destroy servive connection
   if (updateDelay < 1)
      delay(500);  // just to prevent fast loops
      else
      delay(updateDelay*MINUTE - DELAYLOG);
   }
   while (TRUE);
}

void main(int argc, char *argv[])
{
// Setup an exit cleanup procedure
    char   switchValue[20];
    double dtzh;
    int    i;

    signal (SIGINT,  CleanUp);
    signal (SIGTERM, CleanUp);
    signal (SIGABRT, CleanUp);

    if (argc < 2)
       {
       printf("SYNC.NLM  -  NLM to Synchronize File Server Time'\n\n");
       syntax();
       exit(1);
       }
       else
       {
       strcpy(serverName, strupr(argv[1]));  // use parameter to scan other servers

// Check Parameter Time Zone
       tzh = 0;  // defaults = 0
       tzm = 0;
       if (CommandSwitch(argc, argv, "/TZ", switchValue) > 0)
          {
           for (i=0; i<strlen(switchValue); i++)
              if (switchValue[i] == ':') switchValue[i] = '.';
           tzm  = 100 * (modf(atof(switchValue), &dtzh) * 1.001);
           tzh  = dtzh;
           if ((strlen(switchValue) == 0) || (tzh <= -24) || (tzh >= 24) || (tzm > 59))
              {
              syntax();
              exit(1);
              }
           }

// Check Parameter Sync Intervall
       updateDelay = 5;
       if (CommandSwitch(argc, argv, "/I", switchValue) > 0)
          {
           updateDelay = atoi(switchValue);  // parameter in minutes
           if ((strlen(switchValue) == 0) || (updateDelay == 0))
              {
              syntax();
              exit(1);
              }
           }

       TruncLog = (CommandSwitch(argc, argv, "/NL", switchValue) > 0);

       SyncLoop();
       }
}

